#include <sta/devices/arduino/printable_serial.hpp>

#ifdef STA_PLATFORM_ARDUINO

#include <sta/devices/arduino/hal.hpp>
#include <sta/mutex.hpp>

namespace sta
{
    PrintableSerial::PrintableSerial(unsigned long baud, Mutex * mutex /* = nullptr */)
        : Printable{},
          mutex_{mutex}
    {
        Serial.begin(baud);
    }

    void PrintableSerial::print(const char * str, size_t length)
    {
        mutex_->acquire();
        Serial.write(str);
        mutex_->release();
    }
} // namespace sta

#endif // STA_PLATFORM_ARDUINO